# QuickLyric

QuickLyric is an android app that fetches your lyrics for you almost instantly. Its main perks is that it's very fast, doesn't have ads, features a search engine, the downloading of lyrics on your device and some handy settings. While most lyrics app require you to type the name of the song you're searching for or annoy you with tedious notifications every time the song has changed, QuickLyric automatically detects what song is playing on your device and instantly delivers the lyrics to you. QuickLyric makes use of Google's Material Design.

![alt text](http://i.imgur.com/dFjxzpT.png "Banner Logo")

QuickLyric is of course written in Java and runs on phones and tablets equipped with Android 4.0 or higher.
The build system relies on Gradle and Android Studio is therefore recommended.

## Features

* **Lyrics** - Shows the lyrics of the song you are listening to at the moment. The Refresh button allows your to update the lyrics when the next song has started playing. In the action bar, you can to download the lyrics on your device (for offline usage), search and share the URL with a friend.
* **Local Storage** - Each lyrics can be stored on your device.
* **Search** - Search for Lyrics on LyricsNMusic.
* **System Integration** - Access the lyrics you want after you've identified a song with Shazam or Soundhound via the share button. Open URLs from AZLyrics, LyricsNMusic and LyricWikia directly with the app.
* **NFC** - Share lyrics with your friends via Android Beam.
* **More than 10 languages supported** - Including German, Greek, Spanish, French, Italian, Japanese, Dutch, Polish, Russian, Turkish and English.

## Build
* Make sure you have the **latest** version of Gradle installed. You should have at least the version that is used in Quicklyric/build.gradle.
* Download the sources
* Input your signature keystore, login and passwords into the QuickLyric/build.gradle file
* cd to the root of the project and execute "$ gradle build"

## APK

The app is available for download on [F-Droid](https://f-droid.org/repository/browse/?fdfilter=QuickLyric&fdid=be.geecko.QuickLyric).

## Translations

What QuickLyric needs most right now is translations!
If you're bilingual you can submit translations over at [Crowdin](https://crowdin.com/project/quicklyric/invite/public?show_welcome&d=f326bebae52bede2605396991089b9bf380270) (no need to register, just use your GitHub/Google/Facebook/Twitter account). 

**Every translator may request 1 free beer if they live in Brussels.** ;)

## Open Source Contributors

Don't be afraid to contribute! I welcome all forks & pull requests but *please*, if you want to fork QL, immediately update be.geecko.quicklyric.Keys with your own LastFM key.

## Credits

Credits are due to : Last.FM, Roman Nurik for his scroll tricks, Ficus Kirkpatrick for Volley, Jake Wharton for his ViewPagerIndicator and makovkastar for the FloatingActionButton library.

## Screenshots
![Imgur](https://i.imgur.com/Dq6DNoT.png)
![Imgur](https://i.imgur.com/fQd6Gmz.png)
![Imgur](https://i.imgur.com/gULWBIs.png)
![Imgur](https://i.imgur.com/ITCmin4.png)
![Imgur](https://i.imgur.com/i8vgnX9.png)
![Imgur](https://i.imgur.com/S3tgiHn.png)
![Imgur](https://i.imgur.com/3llqmPA.png)

Old screenshots:
![Imgur](http://i.imgur.com/bKq0GLW.png)
![Imgur](https://i.imgur.com/bEdjfIn.png)
![Imgur](http://i.imgur.com/RtIdK24.png)
![Imgur](http://i.imgur.com/dXlxpmJ.png)
